;**********************************************************************
;    Filename:      counter.asm                                       *
;    Date:          07.05.2010                                        *
;    File Version:  v1.0                                              *
;**********************************************************************
;    Files required:                                                  *
;**********************************************************************
;    Notes:                                                           *
;**********************************************************************
;	LIST   P=PIC16F628            ; list directive to define processor
;	#include <P16F628.INC>        ; processor specific variable definitions
;	__CONFIG _CP_OFF &               _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _MCLRE_OFF & _LVP_OFF

	LIST   P=PIC16F628            ; list directive to define processor
	#include <P16F628.INC>        ; processor specific variable definitions

   

;628
	__CONFIG _CP_ALL & _DATA_CP_ON & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT  & _MCLRE_ON & _LVP_OFF    

; ', __ CONFIG '  ,       .asm .
; Lables      .inc .
; .         .
;         ;---------------------------;


;                ; -----------------------------------------------
;***************
magic   macro                           ;""    EEPROM
	movlw   55H            
	movwf   EECON2^80H
	movlw   0AAH
	movwf   EECON2^80H
	endm
;***************
BANK0   macro		;------------------------------------------;
	BCF	STATUS,RP1
	BCF	STATUS,RP0
	endm
;***************
BANK1   macro		;------------------------------------------;
	BCF	STATUS,RP1
	BSF	STATUS,RP0
	endm
;***************
BANK2   macro		;------------------------------------------;
	BSF	STATUS,RP1
	BCF	STATUS,RP0
	endm
;***************
BANK3   macro		;------------------------------------------;
	BSF	STATUS,RP1
	BSF	STATUS,RP0
	endm
;*************** 

;***** VARIABLE DEFINITIONS
w_temp        EQU     0x70        ;       
status_temp   EQU     0x71        ; variable used for context saving
; 

IND_2      EQU        0x72
IND_1      EQU        0x73
IND_0      EQU        0x74

cicle      	EQU        0x75

FLAG			EQU		   0x76		;   

#define   FLAG_REFRESH	    		FLAG,0 ;
#define   FLAG_PRES_COINT			FLAG,1 ;
#define   FLAG_PRES_RESET			FLAG,2 ;
#define   FLAG_3    				FLAG,3 ;  
#define   FLAG_4		  			FLAG,4 ;  
#define   FLAG_5    				FLAG,5 ;  FLAG 
#define   FLAF_6		   			FLAG,6 ;  FLAG 
#define   FLAG_7			  		FLAG,7 ;  FLAG  


IRQ_TMP		EQU		   0x77

COUNT_ML		EQU		   0x78
COUNT_ST		EQU		   0x79

MSECT1		EQU		   0x7A
MSECT2		EQU		   0x7B
TEMP1		EQU		   0x7C



;**************************************************************************
bcd1		EQU		   0x20
bcd2		EQU		   0x21
bcd3		EQU		   0x22
bin1		EQU		   0x23
bin2		EQU		   0x24
ctr			EQU		   0x25

fCOUNTER		EQU		   0x26
fCOUNTER1		EQU		   0x27


;**************************************************************************************************************************
		ORG     0x000             ;  reset vector -  
		goto    START             ;      START


		ORG     0x004 	        ;    
		movwf   w_temp            ;     W 
		movf	STATUS,w          ;       W
		movwf	status_temp       ;     
;    
;*************4 mgz
;   1   = 1000   TMR2

		BCF		PIR1,TMR2IF


;  KEY
;    2  



		BTFSC	PORTA,0
		CLRF	MSECT1

		BTFSC	PORTA,0
		GOTO	IRQ_1

		INCF	MSECT1,F

		MOVLW	.50
		XORWF	MSECT1,W

		BTFSC	STATUS,Z
		BSF		FLAG_PRES_RESET
		
		MOVLW	.55
		SUBWF	MSECT1,W

		MOVLW	.53
		BTFSC	STATUS,C
		MOVWF	MSECT1	
		
		
		

IRQ_1


		BTFSC	PORTA,1
		CLRF	MSECT2

		BTFSC	PORTA,1
		GOTO	IRQ_2

		INCF	MSECT2,F

		MOVLW	.250
		XORWF	MSECT2,W

		BTFSC	STATUS,Z
		BSF		FLAG_PRES_COINT
		
		MOVLW	.254
		SUBWF	MSECT2,W

		MOVLW	.252
		BTFSC	STATUS,C
		MOVWF	MSECT2	
		
IRQ_2
	 

			GOTO	RET_IRQ




RET_IRQ	
;      6 
;   


		MOVLW	0xFF	
		MOVWF	PORTA	; 

		MOVF	cicle,w		;  W  
;  
		btfsc   STATUS,Z
		GOTO 	MCICLE0
		movwf	TEMP1
		decf	TEMP1,F
		btfsc   STATUS,Z
		GOTO 	MCICLE1
		decf	TEMP1,F
		btfsc   STATUS,Z
		GOTO 	MCICLE2

		clrf	cicle
		GOTO 	MCICLE0
				

MCICLE0
		clrf	PORTB
		
		MOVLW	b'11111011'
		MOVWF	PORTA

		MOVF   IND_0,0
		MOVWF	PORTB	;   
				
		goto    ENDIND


MCICLE1
		clrf	PORTB
		MOVLW	b'11110111'
		MOVWF	PORTA

		MOVF   IND_1,0
		MOVWF	PORTB	;   		
		goto    ENDIND
MCICLE2
		clrf	PORTB
		MOVLW	b'11101111'
		MOVWF	PORTA

		MOVF   IND_2,0
		MOVWF	PORTB	;   	
		
		BSF 	FLAG_REFRESH
			
		goto    ENDIND

ENDIND


		INCF	cicle,1 	;   	
		MOVLW	.3
		XORWF	cicle,0
		BTFSC	STATUS,Z
		CLRF	cicle
;********************************		
;	   
;********************************
	
		movf    status_temp,w     ;   
		movwf	STATUS            ;  register contents
		swapf   w_temp,f
		swapf   w_temp,w          ; restore pre-isr W register contents
		retfie                    ; B   
;************************************************************************************************************************





;*********************************************************************;
;=================== LCD TABLE ==================================
;     
; 0 - ........ 7 - 
; :   W   0  7F
; :   W   
LCDTable


	  ANDLW		b'00001111'	
	    				
            addwf      PCL,F        ; W + PC -> PC
;            retlw     ; BFAGCDE- = '8,'	hXX            
            retlw      b'11101110' ; 0 = ABCDEF
            retlw      b'10001000' ; 1 = BC
            retlw      b'10110110' ; 2 = ABDEG
            retlw      b'10111100' ; 3 = ABCDEG
            retlw      b'11011000' ; 4 = BCFG
            retlw      b'01111100' ; 5 = ACDFG
            retlw      b'01111110' ; 6 = ACDEFG
            retlw      b'10101000' ; 7 = ABC
            retlw      b'11111110' ; 8 = ABCDEFG
            retlw      b'11111100' ; 9 = ABCDFG
            retlw      b'11111010' ; A = ABCEFG
            retlw      b'01011110' ; B = CDEFG
            retlw      b'01100110' ; C = ADEF
            retlw      b'10011110' ; D = CDEFG
            retlw      b'01110110' ; E = ADEFG
            retlw      b'01110010' ; F = AEFG
; *****************************************************************************
;**********************************************************************
;  :                               *
;**********************************************************************
START   
		BANK0

		movlw	B'00000111'
		movwf	CMCON
;	BANK1  ;------------------------------------------;

		BANK1
        		MOVLW   	B'00000000'; PORTB           ;
        		MOVWF   	TRISB^80H  ;      trisb = 86h                                    ;
        		MOVLW   	B'00000011';        ;
        		MOVWF   	TRISA^80H  ; 

		movlw    	b'00001111'	; Prescaler -> WDT,
		movwf    	OPTION_REG^80H 	; 1:128, rising edge

		BANK0

	clrf	cicle

	clrf	IND_2
	clrf	IND_1
	clrf	IND_0 


	clrf	COUNT_ML
	clrf	COUNT_ST 
	
			CLRF		FLAG
			
	clrf	MSECT1
	clrf	MSECT2 

		BANK1
	MOVLW	b'00000010'	; IRQ ON FOR TMR2
	MOVWF	PIE1^80


	MOVLW	.249	; MAX COUNT TMR2
	MOVWF	PR2^80

		BANK0
	MOVLW	b'00001101'	; SETTING TMR2
	MOVWF	T2CON		;


	MOVLW	b'11000000'	; GLOBAL IRQ ON
	MOVWF	INTCON		;
                                

;**********************************************************************
;  :    -                 *
;**********************************************************************





;*********************************************************************;

  
BEGIN
;
;		CALL	DELAY_200_MS
;;		CALL	DELAY_200_MS
;;		CALL	DELAY_200_MS
;;		CALL	DELAY_200_MS
;;		CALL	DELAY_200_MS
;
;		INCF		COUNT_ML,F
;		BTFSC		STATUS,Z
;		INCF		COUNT_ST,F
;
;		CALL	REFRESH_DATA
;
;;		goto	BEGIN

;******************************************


		BTFSS 	FLAG_REFRESH
		GOTO	BEGIN1
		BCF 	FLAG_REFRESH	
		CALL	REFRESH_DATA
BEGIN1

		BTFSS 	FLAG_PRES_RESET
		GOTO	BEGIN2
		BCF 	FLAG_PRES_RESET

		CLRF	COUNT_ML
		CLRF	COUNT_ST	
		
		CALL	REFRESH_DATA	
		BCF 	FLAG_REFRESH			
		
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS

;		CLRF	MSECT1		
;		BCF 	FLAG_PRES_RESET		

BEGIN2

		BTFSS 	FLAG_PRES_COINT
		GOTO	BEGIN3
		BCF 	FLAG_PRES_COINT


		INCF		COUNT_ML,F
		BTFSC		STATUS,Z
		INCF		COUNT_ST,F
	
	
		CALL	REFRESH_DATA	
		BCF 	FLAG_REFRESH

		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS


		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS
		CALL	DELAY_200_MS		

BEGIN2A	
		CALL	DELAY_200_MS
		BTFSS	PORTA,1
		GOTO	BEGIN2A	
		
	
		CLRF	MSECT2		
		BCF 	FLAG_PRES_COINT

;1000 = 3E8	

		
		MOVLW	0x03
		XORWF 	COUNT_ST,W
		BTFSS	STATUS,Z
		GOTO	BEGIN3
		
		MOVLW	0xE8
		XORWF 	COUNT_ML,W
		BTFSS	STATUS,Z
		GOTO	BEGIN3		
		
		CLRF	COUNT_ML
		CLRF	COUNT_ST	
		
BEGIN3		
		
		

		GOTO 	BEGIN
		
		
;*********************************************************************;	
REFRESH_DATA



	MOVF	COUNT_ML,W
	MOVWF	bin2
	MOVF	COUNT_ST,W
	MOVWF	bin1		
		
	CALL	BIN2BCD	
	
	MOVF	bcd3,W	
	ANDLW	b'00001111'
	CALL	LCDTable
	MOVWF	IND_0
		

	SWAPF	bcd3,W	
	ANDLW	b'00001111'
	CALL	LCDTable
	MOVWF	IND_1
		
		
	MOVF	bcd2,W	
	ANDLW	b'00001111'
	CALL	LCDTable
	MOVWF	IND_2		
		
	RETURN
		
;*********************************************************************;		




;BIN1:BIN2 - > BCD1:BCD2:BCD3
BIN2BCD        movlw .16 
                movwf ctr 
                clrf bcd1 
                clrf bcd2 
                clrf bcd3 
                goto start 

adjdec          movlw 0x33 
                addwf bcd1,f 
                addwf bcd2,f 
                addwf bcd3,f 

                movlw 0x03 
                btfss bcd1,3 
                subwf bcd1,f 
                btfss bcd2,3 
                subwf bcd2,f 
                btfss bcd3,3 
                subwf bcd3,f 

                movlw 0x30 
                btfss bcd1,7 
                subwf bcd1,f 
                btfss bcd2,7 
                subwf bcd2,f 
                btfss bcd3,7 
                subwf bcd3,f 

start           rlf bin2,f 
                rlf bin1,f 
                rlf bcd3,f 
                rlf bcd2,f 
                rlf bcd1,f 
                decfsz ctr,f 
                goto adjdec 
                return 

;*********************************************************************;
 ;-----------------------------------------------------------------------------

		

DELAY_200_MS
	
		CLRF 	fCOUNTER

		MOVLW	.252
		MOVWF	fCOUNTER1
        goto    BD_Loop94

DELAY_20_MS
	
		CLRF 	fCOUNTER

		MOVLW	.25
		MOVWF	fCOUNTER1



BD_Loop94:
        decfsz  fCOUNTER,1
        goto    BD_Loop94
        decfsz  fCOUNTER1,1
        goto    BD_Loop94

        return 
       
        
;**********************************************************







	END                       ; directive 'end of program'  



